// Header File
// Created 2/4/2005; 5:55:49 PM
#ifndef _MAC
#define _MAC
//internel macros to get a macro to expand to a string
#define _str(s) __str(s)
#define __str(s) #s

#ifndef USE_FLINE_ROM_CALLS
	#define ASM_ROM_CALL(num)  	"	movea.l "_str(num)"*4(%a5),%a0\n	jsr (%a0)\n"
	#define INLINE_ASM_ROM_CALL(num)  	"	movea.l "_str(num)"*4(%%a5),%%a0\n	jsr (%%a0)\n"
#else
	#define ASM_ROM_CALL(num)	"	.word _F_LINE+"_str(num)"\n"
	#define INLINE_ASM_ROM_CALL ASM_ROM_CALL
#endif

//these matke chars into a short or long
#define charsToLong(b3,b2,b1,b0) (((unsigned long)((unsigned char)b3)<<24)|((unsigned long)((unsigned char)b2)<<16)|((unsigned long)((unsigned char)b1)<<8)|((unsigned char)b0))

#define charsToWord(b1,b0) (((unsigned short)((unsigned char)b1)<<8)|((unsigned char)b0))

//"borrowed" from HSR, by Greg Dietsche. this set's the dirty flag so the middle of the screen is redrawn on return to AMS
	#define setDirty()   ({WINDOW *dummy;asm volatile(\
	"____dirtywindows:\n"\
	"	ori.w    #0x2000,(%[Win])        | set Dirty Flag\n"\
	"	tst.l    (0x22,%[Win])           | is there another window?\n"\
	"	movea.l  (0x22,%[Win]),%[Win]       | movea does not affect ccr\n"\
	"	bne.s    ____dirtywindows":[Win]"=a"(dummy):"0"(FirstWindow):"cc");})

//another part of HSR, by Greg Dietsche. it just redraws the statln. not used if a message is displayed on exit.
	#define ST_reset() ({_rom_call(void,(void),E6)();(void)ST_eraseHelp();})

//SB is a programer contraction for small big meaning that the first, small, value is for the small screen
//and the seccond, big, value is for the small screen. basicly it is alot smaller than PSUDO_CONST_SCREEN
#define SB PSEUDO_CONST_SCREEN

//sets two inturupt vectors at the same time
#define Set2IntVec(i0,h0,i1,h1) ({asm volatile ("bclr.b #2,0x600001");(void) (*(INT_HANDLER*)(i0) = (h0));(void) (*(INT_HANDLER*)(i1) = (h1));asm volatile ("bset.b #2,0x600001");(void)i1;})
//I don't like the way GraySetInt1Handler works so I do it my own way
#undef	GraySetInt1Handler
#define GraySetInt1Handler(p) (void)(__gray_old_int1_hw1=(__gray_old_int1_hw2=((INT_HANDLER)p)))

//Time wasting macro
#ifdef USE_VTI
	//for VTI we don't need to save power so use an empty for loop instead
	#define sleep(wake_con)	{register short i;for(i=0;i<900;i++);}
	#warning "Generating VTI version - does NOT save power!"
#else
	//setting 0x600005 equal to stuff makes the calc go into low power mode until an inturupt happens
	#define sleep(wake_con) (void)(*((volatile unsigned char*)(long)(0x600005)) = (wake_con))
#endif

#define GrayDBufGetHiddenPlanes(Dark,Light) (void)(GrayDBufGetHiddenIdx()?(void)(Dark=__D_plane2,Light=__L_plane2):(void)(Dark=__D_plane,Light=__L_plane))
#define GrayDBufGetActivePlanes(Dark,Light) (void)(GrayDBufGetActiveIdx()?(void)(Dark=__D_plane2,Light=__L_plane2):(void)(Dark=__D_plane,Light=__L_plane))

//we need diffrent colition detection for diffrent calcs
#define on_space(x,y,wall) (PSEUDO_CONST_SCREEN(on_space_89(x,y,wall),on_space_92plus_and_v200(x,y,wall)))

#define GrayclearAll() ({void *dummy;asm volatile("move.w #0xEFC,%%d0\n"\
																									"0:\n"\
																									"	clr.l (%0)+\n"\
																									"	dbf %%d0,0b":"=a"(dummy):"0"(D_plane):"cc","d0");(void)dummy;})

#define SmallCopyGrayScreen(dest,src) ({void *dummy0,*dummy1;asm volatile("move.w #0x77C,%%d0\n"\
	"0:\n"\
	"	move.l (%0)+,(%1)+\n"\
	"	dbf %%d0,0b":"=a"(dummy0),"=a"(dummy1):"0"(src),"1"(dest):"cc","d0");(void)dummy0;})


// inserts a name-score pair into the previously sorted hsc list
#define insert(dest,score,name)({char *dummy1,*dummy3;short *dummy0,dummy2;\
				asm volatile(/*coppy score into the last slot*/\
				"	move.w %[score],2(%[scPtr])\n"\
				/*coppy name into the last slot*/\
				"	moveq #" _str(NAME_SIZE-1)",%%d1\n"\
				"place_name:\n"\
					"	move.b (%[Name],%%d1.w)," _str(NAME_SIZE) "(%[namesPtr],%%d1.w)\n"\
				"	dbf %%d1,place_name\n"\
				/*start sort loop*/\
				"	moveq #8,%%d0\n"\
				"_move_up:\n"\
					"	cmp.w (%[scPtr]),%[score]\n"\
					/*at final place exit sort*/\
					"	bls _done\n"\
					/*move the score up one spot*/\
					"	move.w (%[scPtr]),2(%[scPtr])\n"\
					"	move.w %[score],(%[scPtr])\n"\
					"	subq #2,%[scPtr]\n"\
					/*move the name up one spot*/\
					"	moveq #" _str(NAME_SIZE-1) ",%%d1\n"\
					"_move_name:\n"\
						/*this seems to me like the small/slow way but speed is not critical here*/\
						"	move.b (%[namesPtr],%%d1.w),"_str(NAME_SIZE)"(%[namesPtr],%%d1.w)\n"\
						"	move.b (%[Name],%%d1.w),(%[namesPtr],%%d1.w)\n"\
					"	dbf %%d1,_move_name\n"\
					/*move names Ptr to next name*/\
					NEXT_NAME(%[namesPtr])\
					/*end sort loop*/\
				"	dbf %%d0,_move_up\n"\
				"_done:\n":[scPtr]"=a"(dummy0),[namesPtr]"=a"(dummy1),[score]"=d"(dummy2),[Name]"=a"(dummy3):"0"(&((SCORES)dest).scores[8]),"1"(((SCORES)dest).names[8]),"2"((short)score),"3"((char*)name):"cc","d1");(void)dummy0;})

#if NAME_SIZE>8
	#define NEXT_NAME(ptr) "	sub #"_str(NAME_SIZE)","_str(ptr)"\n"
#else
	#define NEXT_NAME(ptr) "	subq #"_str(NAME_SIZE)","_str(ptr)"\n"
#endif

	//this macro initializes a SCORE vareable in a small way
#ifndef VAT_FILES
	#define HSC_init(_dest,_src) ({SCORES *dummy0,*dummy1;\
		 asm volatile("moveq #((20+10*"_str(NAME_SIZE)")/4)-1,%%d0\n"\
		" coppy_loop:\n"\
		"	move.l (%[src])+,(%[dest])+\n"\
		"	dbf %%d0,coppy_loop":[dest]"=a"(dummy0),[src]"=a"(dummy1):"0"(_dest),"1"(_src):"cc");dummy0;})
#endif

#define randomizeWall(_dif) ({unsigned short tmp,dummy;\
						asm(\
						"	subq.w #1,%[dif]\n"\
						"	move.b 0x600017,%%d0\n"\
						"	moveq.l #-1,%[dest]\n"\
						"makeHole:\n"\
						"	lsr.b    #1,%%d0\n"\
    				"	bcc.s    1f\n"\
    				"	eori.b   #0xA3,%%d0\n"\
						"	1:\n"\
						"	moveq.l #-2,%%d1\n"\
						"	rol.w %%d0,%%d1\n"\
						"	and.w %%d1,%[dest]\n"\
						"	dbf      %[dif],makeHole\n"\
						:[dest]"=d" (tmp),[dif]"=d" (dummy):"1" (_dif):"d0","d1","cc");(WALL)tmp;})


	#define DrawStrs(ySt,Strs,num) 	({short dummy,dummy0;void *dummy1;\
	if(__builtin_constant_p(LCD_WIDTH)){\
		asm volatile(\
	 	"	subq.l #1,%[lc]\n"\
	 "draw_loop:\n"\
		"	move.l (%[str]),-(%%sp)\n"\
	 	INLINE_ASM_ROM_CALL(0x27E)\
	 	"	moveq.l %[center],%%d1\n"\
	 	"	mulu.w #3,%%d0\n"\
	 	"	sub.w %%d0,%%d1\n"\
		"	clr.w -(%%sp)\n"\
		"	move.l (%[str])+,-(%%sp)\n"\
		"	move.w %[yPos],-(%%sp)\n"\
		"	move.w %%d1,-(%%sp)\n"\
		INLINE_ASM_ROM_CALL(0x1A9)\
		"	lea (14,%%sp),%%sp\n"\
		"	add.w #10,%[yPos]\n"\
		"	dbf %[lc],draw_loop\n":[str]"=a" (dummy1),[yPos]"=d" (dummy),[lc] "=d"(dummy0):"0" (Strs),"1" (ySt),"2"(num),[center] "gi"((LCD_WIDTH)/2):"a0","a1","d0","d1","d2","cc");\
		}else{\
			asm volatile(\
	 	"	subq.l #1,%[lc]\n"\
	 	"draw_loop:\n"\
		"	move.l (%[str]),-(%%sp)\n"\
	 	INLINE_ASM_ROM_CALL(0x27E)\
	 	"	move.l %[center],%%d1\n"\
	 	"	mulu.w #3,%%d0\n"\
	 	"	sub.w %%d0,%%d1\n"\
		"	clr.w -(%%sp)\n"\
		"	move.l (%[str])+,-(%%sp)\n"\
		"	move.w %[yPos],-(%%sp)\n"\
		"	move.w %%d1,-(%%sp)\n"\
		INLINE_ASM_ROM_CALL(0x1A9)\
		"	lea (14,%%sp),%%sp\n"\
		"	add.w #10,%[yPos]\n"\
		"	dbf %[lc],draw_loop\n":[str]"=a" (dummy1),[yPos]"=d" (dummy),[lc] "=d"(dummy0):"0" (Strs),"1" (ySt),"2"(num),[center] "d"((LCD_WIDTH)/2):"a0","a1","d0","d1","d2","cc");}(void)dummy1;})

#define isSmallScreen() PSEUDO_CONST_SCREEN(TRUE,FALSE)

/*#define GrayClearCenterScreen(Lplane,Dplane) ({\
if(isSmallScreen()){asm volatile(\
"	lea 3(%[light]),%%a0\n"\
"	lea 3(%[dark]),%%a1\n"\
"	moveq #99,%%d0\n"\
"clear_Loop:\n"\
"	and.b #0xFC,(%%a0)+\n"\
"	and.b #0xFC,(%%a1)+\n"\
"	clr.l (%%a0)+\n"\
"	clr.l (%%a1)+\n"\
"	clr.l (%%a0)+\n"\
"	clr.l (%%a1)+\n"\
"	clr.l (%%a0)+\n"\
"	clr.l (%%a1)+\n"\
"	and.b #0x3F,(%%a1)\n"\
"	and.b #0x3F,(%%a0)\n"\
"	lea (17,%%a0),%%a0\n"\
"	lea (17,%%a1),%%a1\n"\
"	dbf      %%d0,clear_Loop\n"::[light]"a" (Lplane),[dark]"a" (Dplane):"d0","a0","a1");\
}else{ asm(\
"	moveq #127,%%d0\n"\
"	lea 7(%[light]),%%a0\n"\
"	lea 7(%[dark]),%%a1\n"\
"_clear_Loop:\n"\
"	clr.b (%%a0)+\n"\
"	clr.b (%%a1)+\n"\
"	clr.l (%%a0)+\n"\
"	clr.l (%%a1)+\n"\
"	clr.l (%%a0)+\n"\
"	clr.l (%%a1)+\n"\
"	clr.l (%%a0)+\n"\
"	clr.l (%%a1)+\n"\
"	clr.w (%%a0)+\n"\
"	clr.w (%%a1)+\n"\
"	clr.b (%%a0)\n"\
"	clr.b (%%a1)\n"\
"	lea (15,%%a0),%%a0\n"\
"	lea (15,%%a1),%%a1\n"\
"	dbf      %%d0,_clear_Loop\n"::[light]"a" (Lplane),[dark]"a" (Dplane):"d0","a0","a1");}(void)Lplane;})*/

#define GrayClearCenterScreen(Dplane) ({\
if(isSmallScreen()){asm volatile(\
"	lea 3(%[dest]),%%a0\n"\
"	lea 0xF00(%%a0),%%a1\n"\
"	moveq #99,%%d0\n"\
"clear_Loop:\n"\
"	and.b #0xFC,(%%a0)+\n"\
"	and.b #0xFC,(%%a1)+\n"\
"	clr.l (%%a0)+\n"\
"	clr.l (%%a1)+\n"\
"	clr.l (%%a0)+\n"\
"	clr.l (%%a1)+\n"\
"	clr.l (%%a0)+\n"\
"	clr.l (%%a1)+\n"\
"	and.b #0x3F,(%%a1)\n"\
"	and.b #0x3F,(%%a0)\n"\
"	lea (17,%%a0),%%a0\n"\
"	lea (17,%%a1),%%a1\n"\
"	dbf      %%d0,clear_Loop\n"::[dest]"a" (Dplane):"d0","a0","a1");\
}else{ asm(\
"	moveq #127,%%d0\n"\
"	lea 7(%[dest]),%%a0\n"\
"	lea 0xF00(%%a0),%%a1\n"\
"_clear_Loop:\n"\
"	clr.b (%%a0)+\n"\
"	clr.b (%%a1)+\n"\
"	clr.l (%%a0)+\n"\
"	clr.l (%%a1)+\n"\
"	clr.l (%%a0)+\n"\
"	clr.l (%%a1)+\n"\
"	clr.l (%%a0)+\n"\
"	clr.l (%%a1)+\n"\
"	clr.w (%%a0)+\n"\
"	clr.w (%%a1)+\n"\
"	clr.b (%%a0)\n"\
"	clr.b (%%a1)\n"\
"	lea (15,%%a0),%%a0\n"\
"	lea (15,%%a1),%%a1\n"\
"	dbf      %%d0,_clear_Loop\n"::[dest]"a" (Dplane):"d0","a0","a1");}(void)Dplane;})

//adapped from fastcoppy screen
/*#define GraySprite160x100_inline(_src,plane0,plane1) ({void *dummy0,*dummy1;asm volatile(\
			"	movem.l  %%d3-%%d6,-(%%sp)\n"\
			"	moveq #1,%%d6\n"\
			"_draw_pic:\n"\
			"	moveq   #99,%%d0\n"\
			"_draw_line:\n"\
			"	movem.l  (%[src])+,%%d1-%%d5\n"\
			"	movem.l  %%d1-%%d5,(%[dest])\n"\
			"	lea      (%[dest],30),%[dest]\n"\
			"	dbf      %%d0,_draw_line\n"\
			"	move.l %[p2],%[dest]\n"\
			"	dbf %%d6,_draw_pic\n"\
			"	movem.l  (%%sp)+,%%d3-%%d6\n"\
			:[src]"=a"(dummy0),[dest]"=a"(dummy1):"0"(_src),"1"(plane1),[p2]"g"(plane0):"cc","d0","d1","d2");(void)dummy0;})*/

#define GraySprite160x100_inline(_src,plane0) ({void *dummy0,*dummy1;asm volatile(\
			"	movem.l  %%d3-%%d6,-(%%sp)\n"\
			"	moveq #1,%%d6\n"\
			"_draw_pic:\n"\
			"	moveq   #99,%%d0\n"\
			"_draw_line:\n"\
			"	movem.l  (%[src])+,%%d1-%%d5\n"\
			"	movem.l  %%d1-%%d5,(%[dest])\n"\
			"	lea      (%[dest],30),%[dest]\n"\
			"	dbf      %%d0,_draw_line\n"\
			"	lea 0x348(%[dest]),%[dest]\n"\
			"	dbf %%d6,_draw_pic\n"\
			"	movem.l  (%%sp)+,%%d3-%%d6\n"\
			:[src]"=a"(dummy0),[dest]"=a"(dummy1):"0"(_src),"1"(plane0):"cc","d0","d1","d2");(void)dummy0;})

//taken from TIGCCLIB and modified to use diffrent names
#define MyGrayDBufToggleSync() ({short __ishw2=GrayHwType;if(__ishw2)({unsigned long __w=GraySwitchCnt+1;while(GraySwitchCnt<__w);});(gray_dbl_offset=(gray_dbl_offset?0:8));if(!__ishw2)({unsigned long __w=GraySwitchCnt+1;while(GraySwitchCnt<__w);});})

#define GrayDBufReset() ((void)(gray_dbl_offset=(0)))
//optomized key reading macro
#define BEGIN_ROWSCAN(row) {register unsigned short _val=_rowread(~(1<<row));

#define _keytest_optimized_mask(rowcol...) __keytest_optimized_mask(rowcol)

#define __keytest_optimized_mask(row,mask) (!!((__current_row==row?__current_rowread_result:(__current_row=row,__current_rowread_result=_rowread_inverted(1<<(row))))&(mask)))

#define rowscan(rowcol...) (_rowscan(rowcol))

#define rowmask(mask)		(!!(_val&(mask)))

#define _rowscan( row, col) (!!(_val&(1<<(col))))

#define END_ROWSCAN  }


#endif